gtkmm 3.2.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions

# Gdk::Pixbuf Class Reference

Inheritance diagram for Gdk::Pixbuf:
[legend]

List of all members.

## Public Types
typedef sigc::slot< void, const guint8* > | SlotDestroyData
## Public Member Functions
virtual | ~Pixbuf ()
GdkPixbuf* | gobj ()
| Provides access to the underlying C GObject.
const GdkPixbuf* | gobj () const
| Provides access to the underlying C GObject.
GdkPixbuf* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::RefPtr< Pixbuf > | copy () const
| Creates a new Gdk::Pixbuf with a copy of the information in the specified pixbuf.
Colorspace | get_colorspace () const
| Queries the color space of a pixbuf.
int | get_n_channels () const
| Queries the number of channels of a pixbuf.
bool | get_has_alpha () const
| Queries whether a pixbuf has an alpha channel (opacity information).
int | get_bits_per_sample () const
| Queries the number of bits per color sample in a pixbuf.
guint8* | get_pixels () const
| Queries a pointer to the pixel data of a pixbuf.
int | get_width () const
| Queries the width of a pixbuf.
int | get_height () const
| Queries the height of a pixbuf.
int | get_rowstride () const
| Queries the rowstride of a pixbuf, which is the number of bytes between the start of a row and the start of the next row.
void | fill (guint32 pixel)
| Clears a pixbuf to the given RGBA value, converting the RGBA value into the pixbuf's pixel format.
void | save (const std::string& filename, const Glib::ustring&type)
| Saves pixbuf to a file in format type.
void | save (const std::string& filename, const Glib::ustring&type, const std::vector< Glib::ustring >& option_keys, const std::vector< Glib::ustring >& option_values)
| Saves pixbuf to a file in format type.
void | save_to_buffer (gchar*& buffer, gsize& buffer_size, const Glib::ustring&type="png")
void | save_to_buffer (gchar*& buffer, gsize& buffer_size, const Glib::ustring&type, const std::vector< Glib::ustring >& option_keys, const std::vector< Glib::ustring >& option_values)
Glib::RefPtr< Gdk::Pixbuf > | add_alpha (bool substitute_color, guint8 r, guint8 g, guint8 b) const
| Takes an existing pixbuf and adds an alpha channel to it.
void | copy_area (int src_x, int src_y, int width, int height, const Glib::RefPtr< Gdk::Pixbuf >& dest_pixbuf, int dest_x, int dest_y) const
| Copies a rectangular area from src_pixbuf to dest_pixbuf.
void | saturate_and_pixelate (const Glib::RefPtr< Gdk::Pixbuf >& dest, float saturation, bool pixelate) const
| Modifies saturation and optionally pixelates src, placing the result in dest.
void | scale (const Glib::RefPtr< Gdk::Pixbuf >& dest, int dest_x, int dest_y, int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, double scale_y, InterpType interp_type) const
| Creates a transformation of the source image src by scaling by scale_x and scale_y then translating by offset_x and offset_y, then renders the rectangle ( dest_x, dest_y, dest_width, dest_height) of the resulting image onto the destination image replacing the previous contents.
void | composite (const Glib::RefPtr< Gdk::Pixbuf >& dest, int dest_x, int dest_y, int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, double scale_y, InterpType interp_type, int overall_alpha) const
| Creates a transformation of the source image src by scaling by scale_x and scale_y then translating by offset_x and offset_y.
void | composite_color (const Glib::RefPtr< Gdk::Pixbuf >& dest, int dest_x, int dest_y, int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, double scale_y, InterpType interp_type, int overall_alpha, int check_x, int check_y, int check_size, guint32 color1, guint32 color2) const
| Creates a transformation of the source image src by scaling by scale_x and scale_y then translating by offset_x and offset_y, then composites the rectangle ( dest_x , dest_y, dest_width, dest_height) of the resulting image with a checkboard of the colors color1 and color2 and renders it onto the destination image.
Glib::RefPtr< Gdk::Pixbuf > | scale_simple (int dest_width, int dest_height, InterpType interp_type) const
| Create a new Gdk::Pixbuf containing a copy of src scaled to dest_width x dest_height.
Glib::RefPtr< Gdk::Pixbuf > | composite_color_simple (int dest_width, int dest_height, InterpType interp_type, int overall_alpha, int check_size, guint32 color1, guint32 color2) const
| Creates a new Gdk::Pixbuf by scaling src to dest_width x dest_height and compositing the result with a checkboard of colors color1 and color2.
Glib::RefPtr< Gdk::Pixbuf > | rotate_simple (PixbufRotation angle) const
| Rotates a pixbuf by a multiple of 90 degrees, and returns the result in a new pixbuf.
Glib::RefPtr< Gdk::Pixbuf > | flip (bool horizontal=true) const
| Flips a pixbuf horizontally or vertically and returns the result in a new pixbuf.
Glib::ustring | get_option (const Glib::ustring& key) const
| Looks up key in the list of options that may have been attached to the pixbuf when it was loaded, or that may have been attached by another function using set_option().
Glib::RefPtr< Pixbuf > | apply_embedded_orientation ()
| Takes an existing pixbuf and checks for the presence of an associated "orientation" option, which may be provided by the jpeg loader (which reads the exif orientation tag) or the tiff loader (which reads the tiff orientation tag, and compensates it for the partial transforms performed by libtiff).
Glib::PropertyProxy_ReadOnly < Colorspace > | property_colorspace () const
| The colorspace in which the samples are interpreted.
Glib::PropertyProxy_ReadOnly< int > | property_n_channels () const
| The number of samples per pixel.
Glib::PropertyProxy_ReadOnly < bool > | property_has_alpha () const
| Whether the pixbuf has an alpha channel.
Glib::PropertyProxy_ReadOnly< int > | property_bits_per_sample () const
| The number of bits per sample.
Glib::PropertyProxy_ReadOnly< int > | property_width () const
| The number of columns of the pixbuf.
Glib::PropertyProxy_ReadOnly< int > | property_height () const
| The number of rows of the pixbuf.
Glib::PropertyProxy_ReadOnly< int > | property_rowstride () const
| The number of bytes between the start of a row and the start of the next row.
Glib::PropertyProxy_ReadOnly < void* > | property_pixels () const
| A pointer to the pixel data of the pixbuf.
## Static Public Member Functions
static Glib::RefPtr< Pixbuf > | create (const Glib::RefPtr< Window >& src, int src_x, int src_y, int width, int height)
| Transfers image data from a #GdkWindow and converts it to an RGB(A) representation inside a Gdk::Pixbuf.
static Glib::RefPtr< Pixbuf > | create (const Cairo::RefPtr< Cairo::Surface >& src, int src_x, int src_y, int width, int height)
static Glib::RefPtr< Pixbuf > | create (Colorspace colorspace, bool has_alpha, int bits_per_sample, int width, int height)
| Creates a new Gdk::Pixbuf structure and allocates a buffer for it.
static Glib::RefPtr< Pixbuf > | create_subpixbuf (const Glib::RefPtr< Pixbuf >& src_pixbuf, int src_x, int src_y, int width, int height)
| Creates a new pixbuf which represents a sub-region of src_pixbuf.
static Glib::RefPtr< Pixbuf > | create_from_file (const std::string& filename)
| Creates a new pixbuf by loading an image from a file.
static Glib::RefPtr< Pixbuf > | create_from_file (const std::string& filename, int width, int height, bool preserve_aspect_ratio=true)
| Creates a new pixbuf by loading an image from a file.
static Glib::RefPtr< Pixbuf > | create_from_data (const guint8* data, Colorspace colorspace, bool has_alpha, int bits_per_sample, int width, int height, int rowstride)
| Creates a new Gdk::Pixbuf out of in-memory image data.
static Glib::RefPtr< Pixbuf > | create_from_data (const guint8* data, Colorspace colorspace, bool has_alpha, int bits_per_sample, int width, int height, int rowstride, const SlotDestroyData& destroy_slot)
| Creates a new Gdk::Pixbuf out of in-memory image data.
static Glib::RefPtr< Pixbuf > | create_from_xpm_data (const char* const* data)
| Creates a new pixbuf by parsing XPM data in memory.
static Glib::RefPtr< Pixbuf > | create_from_inline (int data_length, const guint8* data, bool copy_pixels=false)
| Create a Gdk::Pixbuf from a flat representation that is suitable for storing as inline data in a program.
static Glib::RefPtr< Pixbuf > | create_from_stream (const Glib::RefPtr< Gio::InputStream >& stream, const Glib::RefPtr< Gio::Cancellable >& cancelable)
| Creates a new pixbuf by loading an image from an input stream.
static Glib::RefPtr< Pixbuf > | create_from_stream (const Glib::RefPtr< Gio::InputStream >& stream)
static Glib::RefPtr< Pixbuf > | create_from_stream_at_scale (const Glib::RefPtr< Gio::InputStream >& stream, int width, int height, bool preserve_aspect_ratio, const Glib::RefPtr< Gio::Cancellable >& cancelable)
| Creates a new pixbuf by loading an image from an input stream.
static Glib::RefPtr< Pixbuf > | create_from_stream_at_scale (const Glib::RefPtr< Gio::InputStream >& stream, int width, int height, bool preserve_aspect_ratio)
static std::vector< PixbufFormat > | get_formats ()
| Obtains the available information about the image formats supported by GdkPixbuf.
## Protected Member Functions
| Pixbuf (const Glib::RefPtr< Window >& src, int src_x, int src_y, int width, int height)
| Transfers image data from a #GdkWindow and converts it to an RGB(A) representation inside a Gdk::Pixbuf.
| Pixbuf (const Cairo::RefPtr< Cairo::Surface >& src, int src_x, int src_y, int width, int height)
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gdk::Pixbuf > | wrap (GdkPixbuf* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Member Typedef Documentation

typedef sigc::slot<void, const guint8*> Gdk::Pixbuf::SlotDestroyData

## Constructor & Destructor Documentation

virtual Gdk::Pixbuf::~Pixbuf | ( |  | ) | `[virtual]`

Gdk::Pixbuf::Pixbuf | ( | const Glib::RefPtr< Window >& | src,
|  | int | src_x,
|  | int | src_y,
|  | int | width,
|  | int | height
| ) |  | `[protected]`

Transfers image data from a #GdkWindow and converts it to an RGB(A) representation inside a Gdk::Pixbuf.

In other words, copies image data from a server-side drawable to a client-side RGB(A) buffer. This allows you to efficiently read individual pixels on the client side.

This function will create an RGB pixbuf with 8 bits per channel with the same size specified by the width and height arguments. The pixbuf will contain an alpha channel if the window contains one.

If the window is off the screen, then there is no image data in the obscured/offscreen regions to be placed in the pixbuf. The contents of portions of the pixbuf corresponding to the offscreen region are undefined.

If the window you're obtaining data from is partially obscured by other windows, then the contents of the pixbuf areas corresponding to the obscured regions are undefined.

If the window is not mapped (typically because it's iconified/minimized or not on the current workspace), then an invalid object will be returned.

If memory can't be allocated for the return value, an invalid object will be returned instead.

Parameters:

  src | Source window.
  src_x | Source X coordinate within the window.
  src_y | Source Y coordinate within the window.
  width | Width in pixels of region to get.
  height | Height in pixels of region to get.

Since gtkmm 2.12:

Gdk::Pixbuf::Pixbuf | ( | const Cairo::RefPtr< Cairo::Surface > & | src,
|  | int | src_x,
|  | int | src_y,
|  | int | width,
|  | int | height
| ) |  | `[protected]`

Since gtkmm 2.30:

## Member Function Documentation

Glib::RefPtr<Gdk::Pixbuf> Gdk::Pixbuf::add_alpha | ( | bool | substitute_color,
|  | guint8 | r,
|  | guint8 | g,
|  | guint8 | b
| ) |  | const

Takes an existing pixbuf and adds an alpha channel to it.

If the existing pixbuf already had an alpha channel, the channel values are copied from the original; otherwise, the alpha channel is initialized to 255 (full opacity).

If substitute_color is `true`, then the color specified by ( r, g, b) will be assigned zero opacity. That is, if you pass (255, 255, 255) for the substitute color, all white pixels will become fully transparent.

Parameters:

  substitute_color | Whether to set a color to zero opacity. If this is `false`, then the ( r, g, b) arguments will be ignored.
  r | Red value to substitute.
  g | Green value to substitute.
  b | Blue value to substitute.

Returns:
  A newly-created pixbuf with a reference count of 1.

Glib::RefPtr<Pixbuf> Gdk::Pixbuf::apply_embedded_orientation | ( |  | ) |

Takes an existing pixbuf and checks for the presence of an associated "orientation" option, which may be provided by the jpeg loader (which reads the exif orientation tag) or the tiff loader (which reads the tiff orientation tag, and compensates it for the partial transforms performed by libtiff).

If an orientation option/tag is present, the appropriate transform will be performed so that the pixbuf is oriented correctly.

Since gtkmm 2.12:

Returns:
  A newly-created pixbuf, or a reference to the input pixbuf (with an increased reference count).

void Gdk::Pixbuf::composite | ( | const Glib::RefPtr< Gdk::Pixbuf >& | dest,
|  | int | dest_x,
|  | int | dest_y,
|  | int | dest_width,
|  | int | dest_height,
|  | double | offset_x,
|  | double | offset_y,
|  | double | scale_x,
|  | double | scale_y,
|  | InterpType | interp_type,
|  | int | overall_alpha
| ) |  | const

Creates a transformation of the source image src by scaling by scale_x and scale_y then translating by offset_x and offset_y.

This gives an image in the coordinates of the destination pixbuf. The rectangle ( dest_x, dest_y, dest_width, dest_height) is then composited onto the corresponding rectangle of the original destination image.

When the destination rectangle contains parts not in the source image, the data at the edges of the source image is replicated to infinity.

<figure id="pixbuf-composite-diagram"> <title>Compositing of pixbufs</title> <graphic fileref="composite.png" format="PNG"> </figure>

Parameters:

  dest | The Gdk::Pixbuf into which to render the results.
  dest_x | The left coordinate for region to render.
  dest_y | The top coordinate for region to render.
  dest_width | The width of the region to render.
  dest_height | The height of the region to render.
  offset_x | The offset in the X direction (currently rounded to an integer).
  offset_y | The offset in the Y direction (currently rounded to an integer).
  scale_x | The scale factor in the X direction.
  scale_y | The scale factor in the Y direction.
  interp_type | The interpolation type for the transformation.
  overall_alpha | Overall alpha for source image (0..255).

void Gdk::Pixbuf::composite_color | ( | const Glib::RefPtr< Gdk::Pixbuf >& | dest,
|  | int | dest_x,
|  | int | dest_y,
|  | int | dest_width,
|  | int | dest_height,
|  | double | offset_x,
|  | double | offset_y,
|  | double | scale_x,
|  | double | scale_y,
|  | InterpType | interp_type,
|  | int | overall_alpha,
|  | int | check_x,
|  | int | check_y,
|  | int | check_size,
|  | guint32 | color1,
|  | guint32 | color2
| ) |  | const

Creates a transformation of the source image src by scaling by scale_x and scale_y then translating by offset_x and offset_y, then composites the rectangle ( dest_x , dest_y, dest_width, dest_height) of the resulting image with a checkboard of the colors color1 and color2 and renders it onto the destination image.

See composite_color_simple() for a simpler variant of this function suitable for many tasks.

Parameters:

  dest | The Gdk::Pixbuf into which to render the results.
  dest_x | The left coordinate for region to render.
  dest_y | The top coordinate for region to render.
  dest_width | The width of the region to render.
  dest_height | The height of the region to render.
  offset_x | The offset in the X direction (currently rounded to an integer).
  offset_y | The offset in the Y direction (currently rounded to an integer).
  scale_x | The scale factor in the X direction.
  scale_y | The scale factor in the Y direction.
  interp_type | The interpolation type for the transformation.
  overall_alpha | Overall alpha for source image (0..255).
  check_x | The X offset for the checkboard (origin of checkboard is at - check_x, - check_y).
  check_y | The Y offset for the checkboard.
  check_size | The size of checks in the checkboard (must be a power of two).
  color1 | The color of check at upper left.
  color2 | The color of the other check.

Glib::RefPtr<Gdk::Pixbuf> Gdk::Pixbuf::composite_color_simple | ( | int | dest_width,
|  | int | dest_height,
|  | InterpType | interp_type,
|  | int | overall_alpha,
|  | int | check_size,
|  | guint32 | color1,
|  | guint32 | color2
| ) |  | const

Creates a new Gdk::Pixbuf by scaling src to dest_width x dest_height and compositing the result with a checkboard of colors color1 and color2.

Parameters:

  dest_width | The width of destination image.
  dest_height | The height of destination image.
  interp_type | The interpolation type for the transformation.
  overall_alpha | Overall alpha for source image (0..255).
  check_size | The size of checks in the checkboard (must be a power of two).
  color1 | The color of check at upper left.
  color2 | The color of the other check.

Returns:
  The new Gdk::Pixbuf, or `0` if not enough memory could be allocated for it.

Glib::RefPtr<Pixbuf> Gdk::Pixbuf::copy | ( |  | ) | const

Creates a new Gdk::Pixbuf with a copy of the information in the specified pixbuf.

Returns:
  A newly-created pixbuf with a reference count of 1, or `0` if not enough memory could be allocated.

void Gdk::Pixbuf::copy_area | ( | int | src_x,
|  | int | src_y,
|  | int | width,
|  | int | height,
|  | const Glib::RefPtr< Gdk::Pixbuf >& | dest_pixbuf,
|  | int | dest_x,
|  | int | dest_y
| ) |  | const

Copies a rectangular area from src_pixbuf to dest_pixbuf.

Conversion of pixbuf formats is done automatically.

If the source rectangle overlaps the destination rectangle on the same pixbuf, it will be overwritten during the copy operation. Therefore, you can not use this function to scroll a pixbuf.

Parameters:

  src_x | Source X coordinate within src_pixbuf.
  src_y | Source Y coordinate within src_pixbuf.
  width | Width of the area to copy.
  height | Height of the area to copy.
  dest_pixbuf | Destination pixbuf.
  dest_x | X coordinate within dest_pixbuf.
  dest_y | Y coordinate within dest_pixbuf.

static Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create | ( | const Cairo::RefPtr< Cairo::Surface > & | src,
|  | int | src_x,
|  | int | src_y,
|  | int | width,
|  | int | height
| ) |  | `[static]`

Since gtkmm 2.30:

static Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create | ( | const Glib::RefPtr< Window >& | src,
|  | int | src_x,
|  | int | src_y,
|  | int | width,
|  | int | height
| ) |  | `[static]`

Transfers image data from a #GdkWindow and converts it to an RGB(A) representation inside a Gdk::Pixbuf.

In other words, copies image data from a server-side drawable to a client-side RGB(A) buffer. This allows you to efficiently read individual pixels on the client side.

This function will create an RGB pixbuf with 8 bits per channel with the same size specified by the width and height arguments. The pixbuf will contain an alpha channel if the window contains one.

If the window is off the screen, then there is no image data in the obscured/offscreen regions to be placed in the pixbuf. The contents of portions of the pixbuf corresponding to the offscreen region are undefined.

If the window you're obtaining data from is partially obscured by other windows, then the contents of the pixbuf areas corresponding to the obscured regions are undefined.

If the window is not mapped (typically because it's iconified/minimized or not on the current workspace), then an invalid object will be returned.

If memory can't be allocated for the return value, an invalid object will be returned instead.

Parameters:

  src | Source window.
  src_x | Source X coordinate within the window.
  src_y | Source Y coordinate within the window.
  width | Width in pixels of region to get.
  height | Height in pixels of region to get.

Since gtkmm 2.12:

static Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create | ( | Colorspace | colorspace,
|  | bool | has_alpha,
|  | int | bits_per_sample,
|  | int | width,
|  | int | height
| ) |  | `[static]`

Creates a new Gdk::Pixbuf structure and allocates a buffer for it.

The buffer has an optimal rowstride. Note that the buffer is not cleared; you will have to fill it completely yourself.

Parameters:

  colorspace | Color space for image.
  has_alpha | Whether the image should have transparency information.
  bits_per_sample | Number of bits per color sample.
  width | Width of image in pixels, must be > 0.
  height | Height of image in pixels, must be > 0.

Returns:
  A newly-created Gdk::Pixbuf with a reference count of 1, or `0` if not enough memory could be allocated for the image buffer.

static Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create_from_data | ( | const guint8 * | data,
|  | Colorspace | colorspace,
|  | bool | has_alpha,
|  | int | bits_per_sample,
|  | int | width,
|  | int | height,
|  | int | rowstride
| ) |  | `[static]`

Creates a new Gdk::Pixbuf out of in-memory image data.

Currently only RGB images with 8 bits per sample are supported.

Parameters:

  data | Image data in 8-bit/sample packed format.
  colorspace | Colorspace for the image data.
  has_alpha | Whether the data has an opacity channel.
  bits_per_sample | Number of bits per sample.
  width | Width of the image in pixels.
  height | Height of the image in pixels.
  rowstride | Distance in bytes between rows.

Returns:
  A newly-created Gdk::Pixbuf object.

static Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create_from_data | ( | const guint8 * | data,
|  | Colorspace | colorspace,
|  | bool | has_alpha,
|  | int | bits_per_sample,
|  | int | width,
|  | int | height,
|  | int | rowstride,
|  | const SlotDestroyData & | destroy_slot
| ) |  | `[static]`

Creates a new Gdk::Pixbuf out of in-memory image data.

Currently only RGB images with 8 bits per sample are supported.

Parameters:

  data | Image data in 8-bit/sample packed format.
  colorspace | Colorspace for the image data.
  has_alpha | Whether the data has an opacity channel.
  bits_per_sample | Number of bits per sample.
  width | Width of the image in pixels.
  height | Height of the image in pixels.
  rowstride | Distance in bytes between rows.
  destroy_slot | Slot used to free the data when the pixbuf's reference count drops to zero.

Returns:
  A newly-created Gdk::Pixbuf object.

static Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create_from_file | ( | const std::string & | filename | ) | `[static]`

Creates a new pixbuf by loading an image from a file.

The file format is detected automatically.

Parameters:

  filename | The path to the pixbuf file.

Exceptions:

  Glib::FileError |
  Gdk::PixbufError |

static Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create_from_file | ( | const std::string & | filename,
|  | int | width,
|  | int | height,
|  | bool | preserve_aspect_ratio = `true`
| ) |  | `[static]`

Creates a new pixbuf by loading an image from a file.

The file format is detected automatically. The image will be scaled to fit in the requested size.

Parameters:

  filename | The path to the pixbuf file.
  width | The desired width
  height | The desired height
  preserve_aspect_ratio,: | Whether the image's aspect ratio will be preserved when scaling.

Exceptions:

  Glib::FileError |
  Gdk::PixbufError |

static Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create_from_inline | ( | int | data_length,
|  | const guint8 * | data,
|  | bool | copy_pixels = `false`
| ) |  | `[static]`

Create a Gdk::Pixbuf from a flat representation that is suitable for storing as inline data in a program.

This is useful if you want to ship a program with images, but don't want to depend on any external files.

GTK+ ships with a program called `gdk-pixbuf-csource` which allows for conversion of GdkPixbufs into such a inline representation. In almost all cases, you should pass the `--raw` flag to `gdk-pixbuf-csource`. A sample invocation would be:

`gdk-pixbuf-csource --raw --name=myimage_inline myimage.png`

For the typical case where the inline pixbuf is read-only static data, you don't need to copy the pixel data unless you intend to write to it, so you can pass `false` for copy_pixels. (If you pass `--rle` to `gdk-pixbuf-csource`, a copy will be made even if copy_pixels is `false`, so using this option is generally a bad idea.)

If you create a pixbuf from const inline data compiled into your program, it's probably safe to ignore errors, since things will always succeed. For non-const inline data, you could get out of memory. For untrusted inline data located at runtime, you could have corrupt inline data in addition.

Parameters:

  data_length | Length in bytes of the data argument.
  data | Byte data containing a serialized GdkPixdata structure.
  copy_pixels | Whether to copy the pixel data, or use direct pointers to data for the resulting pixbuf.

Exceptions:

  Gdk::PixbufError |

static Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create_from_stream | ( | const Glib::RefPtr< Gio::InputStream > & | stream | ) | `[static]`

static Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create_from_stream | ( | const Glib::RefPtr< Gio::InputStream > & | stream,
|  | const Glib::RefPtr< Gio::Cancellable > & | cancelable
| ) |  | `[static]`

Creates a new pixbuf by loading an image from an input stream.

The file format is detected automatically. If `0` is returned, then error will be set. The cancellable can be used to abort the operation from another thread. If the operation was cancelled, the error Gio::ERROR_CANCELLED will be returned. Other possible errors are in the Gdk::PIXBUF_ERROR and IO_ERROR domains.

The stream is not closed.

Since gtkmm 2.14:

Parameters:

  stream | A InputStream to load the pixbuf from.
  cancellable | Optional Cancellable object, `0` to ignore.

Returns:
  A newly-created pixbuf, or `0` if any of several error conditions occurred: the file could not be opened, the image format is not supported, there was not enough memory to allocate the image buffer, the stream contained invalid data, or the operation was cancelled.

static Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create_from_stream_at_scale | ( | const Glib::RefPtr< Gio::InputStream > & | stream,
|  | int | width,
|  | int | height,
|  | bool | preserve_aspect_ratio,
|  | const Glib::RefPtr< Gio::Cancellable > & | cancelable
| ) |  | `[static]`

Creates a new pixbuf by loading an image from an input stream.

The file format is detected automatically. If `0` is returned, then error will be set. The cancellable can be used to abort the operation from another thread. If the operation was cancelled, the error Gio::ERROR_CANCELLED will be returned. Other possible errors are in the Gdk::PIXBUF_ERROR and IO_ERROR domains.

The image will be scaled to fit in the requested size, optionally preserving the image's aspect ratio. When preserving the aspect ratio, a width of -1 will cause the image to be scaled to the exact given height, and a height of -1 will cause the image to be scaled to the exact given width. When not preserving aspect ratio, a width or height of -1 means to not scale the image at all in that dimension.

The stream is not closed.

Since gtkmm 2.14:

Parameters:

  stream | A InputStream to load the pixbuf from.
  width | The width the image should have or -1 to not constrain the width.
  height | The height the image should have or -1 to not constrain the height.
  preserve_aspect_ratio | `true` to preserve the image's aspect ratio.
  cancellable | Optional Cancellable object, `0` to ignore.

Returns:
  A newly-created pixbuf, or `0` if any of several error conditions occurred: the file could not be opened, the image format is not supported, there was not enough memory to allocate the image buffer, the stream contained invalid data, or the operation was cancelled.

static Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create_from_stream_at_scale | ( | const Glib::RefPtr< Gio::InputStream > & | stream,
|  | int | width,
|  | int | height,
|  | bool | preserve_aspect_ratio
| ) |  | `[static]`

static Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create_from_xpm_data | ( | const char *const * | data | ) | `[static]`

Creates a new pixbuf by parsing XPM data in memory.

This data is commonly the result of including an XPM file into a program's C source.

Parameters:

  data | Pointer to inline XPM data.

Returns:
  A newly-created pixbuf with a reference count of 1.

static Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create_subpixbuf | ( | const Glib::RefPtr< Pixbuf >& | src_pixbuf,
|  | int | src_x,
|  | int | src_y,
|  | int | width,
|  | int | height
| ) |  | `[static]`

Creates a new pixbuf which represents a sub-region of src_pixbuf.

The new pixbuf shares its pixels with the original pixbuf, so writing to one affects both. The new pixbuf holds a reference to src_pixbuf, so src_pixbuf will not be finalized until the new pixbuf is finalized.

Parameters:

  src_pixbuf | A Gdk::Pixbuf.
  src_x | X coord in src_pixbuf.
  src_y | Y coord in src_pixbuf.
  width | Width of region in src_pixbuf.
  height | Height of region in src_pixbuf.

Returns:
  A new pixbuf.

void Gdk::Pixbuf::fill | ( | guint32 | pixel | ) |

Clears a pixbuf to the given RGBA value, converting the RGBA value into the pixbuf's pixel format.

The alpha will be ignored if the pixbuf doesn't have an alpha channel.

Parameters:

  pixel | RGBA pixel to clear to (0xffffffff is opaque white, 0x00000000 transparent black).

Glib::RefPtr<Gdk::Pixbuf> Gdk::Pixbuf::flip | ( | bool | horizontal = `true` | ) | const

Flips a pixbuf horizontally or vertically and returns the result in a new pixbuf.

Since gtkmm 2.6:

Parameters:

  horizontal | `true` to flip horizontally, `false` to flip vertically.

Returns:
  The new Gdk::Pixbuf, or `0` if not enough memory could be allocated for it.

int Gdk::Pixbuf::get_bits_per_sample | ( |  | ) | const

Queries the number of bits per color sample in a pixbuf.

Returns:
  Number of bits per color sample.

Colorspace Gdk::Pixbuf::get_colorspace | ( |  | ) | const

Queries the color space of a pixbuf.

Returns:
  Color space.

static std::vector<PixbufFormat> Gdk::Pixbuf::get_formats | ( |  | ) | `[static]`

Obtains the available information about the image formats supported by GdkPixbuf.

Returns:
  A list of PixbufFormats describing the supported image formats.

bool Gdk::Pixbuf::get_has_alpha | ( |  | ) | const

Queries whether a pixbuf has an alpha channel (opacity information).

Returns:
  `true` if it has an alpha channel, `false` otherwise.

int Gdk::Pixbuf::get_height | ( |  | ) | const

Queries the height of a pixbuf.

Returns:
  Height in pixels.

int Gdk::Pixbuf::get_n_channels | ( |  | ) | const

Queries the number of channels of a pixbuf.

Returns:
  Number of channels.

Glib::ustring Gdk::Pixbuf::get_option | ( | const Glib::ustring & | key | ) | const

Looks up key in the list of options that may have been attached to the pixbuf when it was loaded, or that may have been attached by another function using set_option().

For instance, the ANI loader provides "Title" and "Artist" options. The ICO, XBM, and XPM loaders provide "x_hot" and "y_hot" hot-spot options for cursor definitions. The PNG loader provides the tEXt ancillary chunk key/value pairs as options. Since 2.12, the TIFF and JPEG loaders return an "orientation" option string that corresponds to the embedded TIFF/Exif orientation tag (if present).

Parameters:

  key | A nul-terminated string.

Returns:
  The value associated with key. This is a nul-terminated string that should not be freed or `0` if key was not found.

guint8* Gdk::Pixbuf::get_pixels | ( |  | ) | const

Queries a pointer to the pixel data of a pixbuf.

Returns:
  A pointer to the pixbuf's pixel data. Please see <xref linkend="image-data"> for information about how the pixel data is stored in memory.

int Gdk::Pixbuf::get_rowstride | ( |  | ) | const

Queries the rowstride of a pixbuf, which is the number of bytes between the start of a row and the start of the next row.

Returns:
  Distance between row starts.

int Gdk::Pixbuf::get_width | ( |  | ) | const

Queries the width of a pixbuf.

Returns:
  Width in pixels.

const GdkPixbuf* Gdk::Pixbuf::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Gio::Icon.

GdkPixbuf* Gdk::Pixbuf::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Gio::Icon.

GdkPixbuf* Gdk::Pixbuf::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Glib::PropertyProxy_ReadOnly<int> Gdk::Pixbuf::property_bits_per_sample | ( |  | ) | const

The number of bits per sample.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Colorspace> Gdk::Pixbuf::property_colorspace | ( |  | ) | const

The colorspace in which the samples are interpreted.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gdk::Pixbuf::property_has_alpha | ( |  | ) | const

Whether the pixbuf has an alpha channel.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<int> Gdk::Pixbuf::property_height | ( |  | ) | const

The number of rows of the pixbuf.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<int> Gdk::Pixbuf::property_n_channels | ( |  | ) | const

The number of samples per pixel.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<void*> Gdk::Pixbuf::property_pixels | ( |  | ) | const

A pointer to the pixel data of the pixbuf.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<int> Gdk::Pixbuf::property_rowstride | ( |  | ) | const

The number of bytes between the start of a row and the start of the next row.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<int> Gdk::Pixbuf::property_width | ( |  | ) | const

The number of columns of the pixbuf.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::RefPtr<Gdk::Pixbuf> Gdk::Pixbuf::rotate_simple | ( | PixbufRotation | angle | ) | const

Rotates a pixbuf by a multiple of 90 degrees, and returns the result in a new pixbuf.

Since gtkmm 2.6:

Parameters:

  angle | The angle to rotate by.

Returns:
  The new Gdk::Pixbuf, or `0` if not enough memory could be allocated for it.

void Gdk::Pixbuf::saturate_and_pixelate | ( | const Glib::RefPtr< Gdk::Pixbuf >& | dest,
|  | float | saturation,
|  | bool | pixelate
| ) |  | const

Modifies saturation and optionally pixelates src, placing the result in dest.

src and dest may be the same pixbuf with no ill effects. If saturation is 1.0 then saturation is not changed. If it's less than 1.0, saturation is reduced (the image turns toward grayscale); if greater than 1.0, saturation is increased (the image gets more vivid colors). If pixelate is `true`, then pixels are faded in a checkerboard pattern to create a pixelated image. src and dest must have the same image format, size, and rowstride.

Parameters:

  dest | Place to write modified version of src.
  saturation | Saturation factor.
  pixelate | Whether to pixelate.

void Gdk::Pixbuf::save | ( | const std::string & | filename,
|  | const Glib::ustring & | type,
|  | const std::vector< Glib::ustring > & | option_keys,
|  | const std::vector< Glib::ustring > & | option_values
| ) |  |

Saves pixbuf to a file in format type.

By default, "jpeg", "png", "ico" and "bmp" are possible file formats to save in, but more formats may be installed. TThe list of all writable formats can be determined by using get_formats() with Gdk::PixbufFormat::is_writable().

The option_keys and , if not empty, should contain pairs of strings that modify the save parameters. For example, "quality", "100".

Currently only a few parameters exist. JPEG images can be saved with a "quality" parameter; its value should be in the range [0,100]. Text chunks can be attached to PNG images by specifying parameters of the form "tEXt::key", where key is an ASCII string of length 1-79. The values are UTF-8 encoded strings. ICO images can be saved in depth 16, 24, or 32, by using the "depth" parameter. When the ICO saver is given "x_hot" and "y_hot" parameters, it produces a CUR instead of an ICO.

Parameters:

  filename | The path of the file to be created.
  type | The file type.
  option_keys |
  option_values |

Exceptions:

  Glib::FileError |
  Gdk::PixbufError |

void Gdk::Pixbuf::save | ( | const std::string & | filename,
|  | const Glib::ustring & | type
| ) |  |

Saves pixbuf to a file in format type.

By default, "jpeg", "png", "ico" and "bmp" are possible file formats to save in, but more formats may be installed. The list of all writable formats can be determined by using get_formats() with is_writable().

Parameters:

  filename | The path of the file to be created.
  type | The file type.

Exceptions:

  Glib::FileError |
  Gdk::PixbufError |

void Gdk::Pixbuf::save_to_buffer | ( | gchar *& | buffer,
|  | gsize & | buffer_size,
|  | const Glib::ustring & | type,
|  | const std::vector< Glib::ustring > & | option_keys,
|  | const std::vector< Glib::ustring > & | option_values
| ) |  |

void Gdk::Pixbuf::save_to_buffer | ( | gchar *& | buffer,
|  | gsize & | buffer_size,
|  | const Glib::ustring & | type = `"png"`
| ) |  |

void Gdk::Pixbuf::scale | ( | const Glib::RefPtr< Gdk::Pixbuf >& | dest,
|  | int | dest_x,
|  | int | dest_y,
|  | int | dest_width,
|  | int | dest_height,
|  | double | offset_x,
|  | double | offset_y,
|  | double | scale_x,
|  | double | scale_y,
|  | InterpType | interp_type
| ) |  | const

Creates a transformation of the source image src by scaling by scale_x and scale_y then translating by offset_x and offset_y, then renders the rectangle ( dest_x, dest_y, dest_width, dest_height) of the resulting image onto the destination image replacing the previous contents.

Try to use scale_simple() first, this function is the industrial-strength power tool you can fall back to if scale_simple() isn't powerful enough.

If the source rectangle overlaps the destination rectangle on the same pixbuf, it will be overwritten during the scaling which results in rendering artifacts.

Parameters:

  dest | The Gdk::Pixbuf into which to render the results.
  dest_x | The left coordinate for region to render.
  dest_y | The top coordinate for region to render.
  dest_width | The width of the region to render.
  dest_height | The height of the region to render.
  offset_x | The offset in the X direction (currently rounded to an integer).
  offset_y | The offset in the Y direction (currently rounded to an integer).
  scale_x | The scale factor in the X direction.
  scale_y | The scale factor in the Y direction.
  interp_type | The interpolation type for the transformation.

Glib::RefPtr<Gdk::Pixbuf> Gdk::Pixbuf::scale_simple | ( | int | dest_width,
|  | int | dest_height,
|  | InterpType | interp_type
| ) |  | const

Create a new Gdk::Pixbuf containing a copy of src scaled to dest_width x dest_height.

Leaves src unaffected. interp_type should be Gdk::INTERP_NEAREST if you want maximum speed (but when scaling down Gdk::INTERP_NEAREST is usually unusably ugly). The default interp_type should be Gdk::INTERP_BILINEAR which offers reasonable quality and speed.

You can scale a sub-portion of src by creating a sub-pixbuf pointing into src; see new_subpixbuf().

For more complicated scaling/compositing see scale() and composite().

Parameters:

  dest_width | The width of destination image.
  dest_height | The height of destination image.
  interp_type | The interpolation type for the transformation.

Returns:
  The new Gdk::Pixbuf, or `0` if not enough memory could be allocated for it.

## Friends And Related Function Documentation

Glib::RefPtr< Gdk::Pixbuf > wrap | ( | GdkPixbuf * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gdkmm/pixbuf.h